#ifndef _CI_RESULT_H_
#define _CI_RESULT_H_

#include <iostream.h>
#include "CiConfig.h"

class CiResult {
public:
	//geometry setup:
	double tranmission_efficient[MAX_NUM_ZENITH_DIVISION];
    double trans_coeff_diffuse;
	double lai;
	double mean_leaf_angle;
	double x;

	double leaf_distribution[MAX_NUM_AZMUTHAL_DIVISION];

	CiResult()
	{
		trans_coeff_diffuse = 0.;
		lai = 0.;
		mean_leaf_angle = 0.;
		x = 0.;
		memset(tranmission_efficient, 0, MAX_NUM_ZENITH_DIVISION * sizeof(double));
		memset(leaf_distribution, 0, MAX_NUM_AZMUTHAL_DIVISION * sizeof(double));
	}
};

#endif