#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// DibBlankoutDialog.h : header file
//

#include "DibDoc.h"
#include "DibView.h"
#include "Mainfrm.h"

/////////////////////////////////////////////////////////////////////////////
// CDibBlankoutDialog dialog

#ifndef _CI_CDIBBLANKOUTDIALOG_H_
#define _CI_CDIBBLANKOUTDIALOG_H_

class CDibBlankoutDialog : public CDialog
{
// Construction
public:
	CDibBlankoutDialog(CDibDoc* pDoc, CWnd* pParent = NULL);   // standard constructor

	BOOL	blankout_applied;
	CDibDoc* pDoc;
	BOOL	m_blankout_flag;
	void	UpdateState();
// Dialog Data
	//{{AFX_DATA(CDibBlankoutDialog)
	enum { IDD = IDD_BLANKOUT_DIALOG };
	int		m_blankout_start;
	int		m_blankout_end;
	int		m_thresh_level;
	double  m_PARzerocal;
	double  m_PARspancal;
	double  m_Fleckszerocal;
	double  m_Flecksspancal;
	double  m_Latitude;
	int m_month1;
	int m_day1;
	int m_month2;
	int m_day2;

	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDibBlankoutDialog)
	public:
	virtual BOOL DestroyWindow();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CDibBlankoutDialog)
	afx_msg void OnRadioNo();
	afx_msg void OnRadioYes();
	afx_msg void OnButtonApply();
	afx_msg void OnButtonOk();
	afx_msg void OnButtonCancel();
	virtual BOOL OnInitDialog();
	afx_msg void OnChangeThreshLevel();
	afx_msg void OnChangeBlankoutStart();
	afx_msg void OnChangeBlankoutEndAngle();
	afx_msg void OnChangeMeasuresetupBlankoutEnd();
	afx_msg void OnChangeMeasuresetupBlankoutStart();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
	void DrawBlankoutRegion();
};

#endif
