// DibView.cpp : implementation of the CDibView class
//

/*
//
// COORDINATE SYSTEM FOR WINDOW'S WINDOW, VIEW WINDOW AND IMAGE WINDOW
//
//
//
//	------------------------------------> Window Width
//	|
//	|
//	|   ^ Image Height
//	|   |
//	|   |
//	|   |		o
//	|   |		  \
//	|   |			\ Raduis
//	|	|			  
//	|   |----------------> Image Width
//	|
//	V Window Height
//
*/



#include <windowsx.h> 



#include <cstring>


#include <math.h>
#include <stdio.h>
#include <process.h>


#include <malloc.h>





#pragma comment( lib, "setupapi.lib")

// Belkin:  {4D36E96C-E325-11CE-BFC1-08002BE10318}
// {17CCA71B-ECD7-11D0-B908-00A0C9223196}
/*Multimedia
    Class = Media
    ClassGuid = {4d36e96c-e325-11ce-bfc1-08002be10318}

    This class includes Audio and DVD multimedia devices, joystick ports, and full-motion video capture devices. 
*/


#define MMCAPS_DEVTYPE_WAVEIN       7
extern double FlecksThreshold;
extern double PARgain;




#include <stdlib.h>

#include "stdafx.h"
#include "Dib.h"
#include <windows.h>
#include <mmsystem.h>
#include <mmreg.h>
#include "Eztwain.h"
#include "CiConfig.h"
#include <vfw.h>
#include <setupapi.h>
#include <devguid.h>
#include <regstr.h>


#include "DibDoc.h"
#include "DibView.h"
#include "Mainfrm.h"
#include <initguid.h>
DEFINE_GUID(GUID_BELKINAUDIO, 0x4D36E96C, 0xE325, 0x11CE, 0xBF, 0xC1, 0x08,
            0x00, 0x2B, 0xE1, 0x03, 0x18);
DEFINE_GUID(GUID_BELKINAUDIO1, 0x17CCA71B, 0xECD7, 0x11D0, 0xB9, 0x08, 0x00,
            0xA0, 0xC9, 0x22, 0x31, 0x96);

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern double ci_sqrt(double x);

extern CiConfigImage* ci_config_image;
extern CiConfigOutput* ci_config_output;

extern double PAR,Flecks;

typedef struct{
	double PAR;
	double Flecks;
	int measure;
	int count;
	bool bTESTOUT;
} PARFlecks;
extern PARFlecks PARFlecksValue;

extern CMainFrame* mainFrame;


#define	WINMMAPI	DECLSPEC_IMPORT

#define MMSYSERR_NOERROR      0                    /* no error */
typedef UINT        MMRESULT;   /* error return code, 0 means no error */
				/* call as if(err=xxxx(...)) Error(err); else */
/*typedef struct tWAVEFORMATEX
/*{
    /*WORD        wFormatTag;         /* format type */
    /*WORD        nChannels;          /* number of channels (i.e. mono, stereo...) */
    /*DWORD       nSamplesPerSec;     /* sample rate */
    /*DWORD       nAvgBytesPerSec;    /* for buffer estimation */
    /*WORD        nBlockAlign;        /* block size of data */
    /*WORD        wBitsPerSample;     /* number of bits per sample of mono data */
    /*WORD        cbSize;             /* the count in bytes of the size of */
				    /* extra information (after cbSize) */
/*} WAVEFORMATEX, *PWAVEFORMATEX, NEAR *NPWAVEFORMATEX, FAR *LPWAVEFORMATEX;
*/typedef const WAVEFORMATEX FAR *LPCWAVEFORMATEX;
/* wave data block header */
/*typedef struct wavehdr_tag {
    /*LPSTR       lpData;                 /* pointer to locked data buffer */
    /*DWORD       dwBufferLength;         /* length of data buffer */
    /*DWORD       dwBytesRecorded;        /* used for input only */
    /*DWORD       dwUser;                 /* for client's use */
    /*DWORD       dwFlags;                /* assorted flags (see defines) */
    /*DWORD       dwLoops;                /* loop control counter */
    /*struct wavehdr_tag FAR *lpNext;     /* reserved for driver */
    /*DWORD       reserved;               /* reserved for driver */
/*} WAVEHDR, *PWAVEHDR, NEAR *NPWAVEHDR, FAR *LPWAVEHDR;
*/
typedef UINT        MMVERSION;  /* major (high byte), minor (low byte) */
#define MAXPNAMELEN      32     /* max product name length (including NULL) */
#define MAXERRORLENGTH   256    /* max error text length (including NULL) */
/*typedef struct tagWAVEINCAPSA {
    /*WORD    wMid;                    /* manufacturer ID */
    /*WORD    wPid;                    /* product ID */
    /*MMVERSION vDriverVersion;        /* version of the driver */
    /*CHAR    szPname[MAXPNAMELEN];    /* product name (NULL terminated string) */
    /*DWORD   dwFormats;               /* formats supported */
    /*WORD    wChannels;               /* number of channels supported */
    /*WORD    wReserved1;              /* structure packing */
/*} WAVEINCAPSA, *PWAVEINCAPSA, *NPWAVEINCAPSA, *LPWAVEINCAPSA;
*/
typedef WAVEINCAPSA WAVEINCAPS;
#define waveInGetDevCaps  waveInGetDevCapsA

typedef HWAVEIN FAR *LPHWAVEIN;
WINMMAPI MMRESULT WINAPI waveInGetDevCapsA(UINT uDeviceID, LPWAVEINCAPSA pwic, UINT cbwic);
WINMMAPI MMRESULT WINAPI waveInOpen(LPHWAVEIN phwi, UINT uDeviceID,
    LPCWAVEFORMATEX pwfx, DWORD dwCallback, DWORD dwInstance, DWORD fdwOpen);
WINMMAPI MMRESULT WINAPI waveInStop(HWAVEIN hwi);
WINMMAPI MMRESULT WINAPI waveInReset(HWAVEIN hwi);
WINMMAPI MMRESULT WINAPI waveInClose(HWAVEIN hwi);
WINMMAPI MMRESULT WINAPI waveInStart(HWAVEIN hwi);
WINMMAPI MMRESULT WINAPI waveInUnprepareHeader(HWAVEIN hwi, LPWAVEHDR pwh, UINT cbwh);
WINMMAPI MMRESULT WINAPI waveInPrepareHeader(HWAVEIN hwi, LPWAVEHDR pwh, UINT cbwh);
WINMMAPI MMRESULT WINAPI waveInAddBuffer(HWAVEIN hwi, LPWAVEHDR pwh, UINT cbwh);
WINMMAPI UINT WINAPI waveInGetNumDevs(void);
#define WAVE_FORMAT_PCM     1
#define WHDR_DONE       0x00000001  /* done bit */
#define CALLBACK_NULL       0x00000000l    /* no callback */
#define  WAVE_FORMAT_DIRECT        0x0008
//extern MMCAPS_DEVTYPE_WAVEIN;

//DECLARE_HANDLE(HWAVEIN);




extern double FlecksThreshold;
extern double PARgain;
extern CiConfigGeometry* ci_config_geometry;
/////////////////////////////////////////////////////////////////////////////
// CDibView

//IMPLEMENT_DYNCREATE(CDibView, CScrollView)
IMPLEMENT_DYNCREATE(CDibView, CView)

//BEGIN_MESSAGE_MAP(CDibView, CScrollView)
BEGIN_MESSAGE_MAP(CDibView, CView)
	//{{AFX_MSG_MAP(CDibView)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
	// Standard printing commands
	//ON_COMMAND(ID_FILE_PRINT, CScrollView::OnFilePrint)
	//ON_COMMAND(ID_FILE_PRINT_DIRECT, CScrollView::OnFilePrint)
	//ON_COMMAND(ID_FILE_PRINT_PREVIEW, CScrollView::OnFilePrintPreview)
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDibView construction/destruction

CDibView::CDibView()
		:sizeTotal(400,300), sizePage(400,300), sizeLine(10,10)
{
	m_imageAdjustment = FALSE;
	m_bCaptured = FALSE;
	m_resizing = FALSE;
}

CDibView::~CDibView()
{
}

BOOL CDibView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	//return CScrollView::PreCreateWindow(cs);
	return CView::PreCreateWindow(cs);
}

void CDibView::DrawCameraIcon(CDC* pDC, CRect rc)
{
	CDibDoc* pDoc = GetDocument();
	float view_center_x = (rc.left + rc.right) / 2.;
	float view_center_y = (rc.top + rc.bottom) / 2.;
	int top = (int)(view_center_y - ci_config_image->max_msrbl_image_y * pDoc->viewImageScale / 2.);
	int bottom = (int)(view_center_y + ci_config_image->max_msrbl_image_y * pDoc->viewImageScale / 2.);
	int left = (int)(view_center_x - ci_config_image->max_msrbl_image_x * pDoc->viewImageScale / 2.);
	int right = (int)(view_center_x + ci_config_image->max_msrbl_image_x * pDoc->viewImageScale / 2.);
	pDC->Rectangle(left, top, right, bottom);

	CBrush brush;
	if (!brush.CreateSolidBrush(RGB(255, 0, 0)))
		return;

	brush.UnrealizeObject();
	int pole_length = (int) (30 * pDoc->viewImageScale);
	int pole_width = (int) (2 * pDoc->viewImageScale);
	int base_length = (int) (20 * pDoc->viewImageScale);
	int base_width = (int) (10 * pDoc->viewImageScale);
	int start_x = right - (int) (20 * pDoc->viewImageScale);
	int start_y = bottom - (int) (60 * pDoc->viewImageScale);
	int temp_x = start_x + (base_width - pole_width)/2;
	int temp_y = start_y;
	CRect rect1(temp_x, temp_y, temp_x+pole_width, temp_y+pole_length);
	pDC->FillRect(rect1, &brush);

	temp_x = start_x;
	temp_y = start_y + pole_length;
	CRect rect2(temp_x, temp_y, temp_x+base_width, temp_y+base_length);
	pDC->FillRect(rect2, &brush);
}

void CDibView::DrawCordinateBorder(CDC* pDC, CRect rc)
{
	pDC->SelectStockObject(HOLLOW_BRUSH);
	CDibDoc* pDoc = GetDocument();
	float view_center_x = (rc.left + rc.right) / 2.;
	float view_center_y = (rc.top + rc.bottom) / 2.;
	int top = (int)(view_center_y - ci_config_image->max_msrbl_image_y * pDoc->viewImageScale / 2.);
	int bottom = (int)(view_center_y + ci_config_image->max_msrbl_image_y * pDoc->viewImageScale / 2.);
	int left = (int)(view_center_x - ci_config_image->max_msrbl_image_x * pDoc->viewImageScale / 2.);
	int right = (int)(view_center_x + ci_config_image->max_msrbl_image_x * pDoc->viewImageScale / 2.);
	char cvalue[6];
	pDC->Rectangle(left, top, right, bottom);
    if(ci_config_output->bPAR)
	{
		// PARFlecks(); makes the form slow to load
		pDC->TextOut(right-100,top+22,"PAR");
		pDC->TextOut(right-135,top+5,"Sunflecks");
		sprintf(cvalue,"%4.1f%%",::Flecks);
		pDC->TextOut(right-60,top+5,cvalue);
		sprintf(cvalue,"%4.1f",::PAR);
		pDC->TextOut(right-60,top+22,cvalue);
	}

 //   if(!ci_config_output->bSUNTRACK)
//	{
//		pDC->TextOut(right-4, (int)view_center_y, "0");
//		pDC->TextOut((int)view_center_x -8, top-8, "90");
//		pDC->TextOut(left-10, (int)view_center_y, "180");
//		pDC->TextOut((int)view_center_x - 10, bottom-8, "270");
//	}
//	else
//	{
		pDC->TextOut(right-13, (int)view_center_y, "270");
		pDC->TextOut(right-4, (int)view_center_y-15, "W");
		pDC->TextOut((int)view_center_x -8, top-8, "0 N");
		pDC->TextOut(left-10, (int)view_center_y-15, "E");
		pDC->TextOut(left-10, (int)view_center_y, "90");
		pDC->TextOut((int)view_center_x - 10, bottom-8, "S 180");
//	}
}

void CDibView::DocToClient(CRect& rect)
{
	CClientDC dc(this);
	OnPrepareDC(&dc, NULL);
	dc.LPtoDP(rect);
	rect.NormalizeRect();
}

/////////////////////////////////////////////////////////////////////////////
// CDibView drawing

void CDibView::OnDraw(CDC* pDC)
{

	CDibDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	CDC dc;
	CDC* pDrawDC = pDC;
	CBitmap bitmap;
	CBitmap* pOldBitmap;
	//char tmpBuf[256];

	/*
	sprintf(tmpBuf, "\n\n\nCDibView::OnDraw().\n");
	OutputDebugString(tmpBuf);
	*/

	// only paint the rect that needs repainting
	CRect client;
	pDC->GetClipBox(client);
	CRect rect = client;
	DocToClient(rect);

	CRect prefRect(0, 0, (int)(ci_config_image->max_msrbl_image_x * pDoc->viewImageScale) + 2 * VIEW_BORDER_X, (int)(ci_config_image->max_msrbl_image_y * pDoc->viewImageScale) + 2 * VIEW_BORDER_X);
	
	/*
	sprintf(tmpBuf, "pDoc->viewImageScale: %f.\n", pDoc->viewImageScale);
	OutputDebugString(tmpBuf);
	sprintf(tmpBuf, "rect.Width(): %d.\n", rect.Width());
	OutputDebugString(tmpBuf);
	sprintf(tmpBuf, "rect.Height(): %d.\n", rect.Height());
	OutputDebugString(tmpBuf);
	sprintf(tmpBuf, "prefRect.Width(): %d.\n", prefRect.Width());
	OutputDebugString(tmpBuf);
	sprintf(tmpBuf, "prefRect.Height(): %d.\n", prefRect.Height());
	OutputDebugString(tmpBuf);
	*/
	if (mainFrame->needResize == TRUE)
	{
		//if (rect.Width() != prefRect.Width() || rect.Height() != prefRect.Height())
		{
			CRect frameRect;
			mainFrame->GetWindowRect(frameRect);
			mainFrame->SetWindowPos(NULL, 0, 0,
				frameRect.Width() + prefRect.Width() - rect.Width(),
				frameRect.Height() + prefRect.Height() - rect.Height(),
				SWP_NOZORDER|SWP_NOMOVE);
		}
		mainFrame->needResize = FALSE;
		//return;
	}

	//This is temporarily used to adjust image_area/print_area ratio.
	float oldViewImageScale = pDoc->viewImageScale;

	if (!pDC->IsPrinting())
	{
		// draw to offscreen bitmap for fast looking repaints
		if (dc.CreateCompatibleDC(pDC))
		{
			if (bitmap.CreateCompatibleBitmap(pDC, rect.Width(), rect.Height()))
			{
				OnPrepareDC(&dc, NULL);
				pDrawDC = &dc;

				// offset origin more because bitmap is just piece of the whole drawing
				dc.OffsetViewportOrg(-rect.left, -rect.top);
				pOldBitmap = dc.SelectObject(&bitmap);
				dc.SetBrushOrg(rect.left % 8, rect.top % 8);

				// might as well clip to the same rectangle
				dc.IntersectClipRect(client);
			}
		}
	}
	else //if (pDC->IsPrinting() )   // printer DC
	{
		if (pDoc->m_fillWhenPrint)
		{
			// get size of printer page (in pixels)
			int cxPage = pDC->GetDeviceCaps(HORZRES);
			int cyPage = pDC->GetDeviceCaps(VERTRES);

			/*
			sprintf(tmpBuf, "cxPage: %d.\n", cxPage);
			OutputDebugString(tmpBuf);
			sprintf(tmpBuf, "cyPage: %d.\n", cyPage);
			OutputDebugString(tmpBuf);
			*/

			/*
			// get printer pixels per inch
			int cxInch = pDC->GetDeviceCaps(LOGPIXELSX);
			int cyInch = pDC->GetDeviceCaps(LOGPIXELSY);

			//
			// Best Fit case -- create a rectangle which preserves
			// the DIB's aspect ratio, and fills the page horizontally.
			//
			// The formula in the "->bottom" field below calculates the Y
			// position of the printed bitmap, based on the size of the
			// bitmap, the width of the page, and the relative size of
			// a printed pixel (cyInch / cxInch).
			//
			rcDest.top = rcDest.left = 0;
			rcDest.bottom = (int)(((double)cyDIB * cxPage * cyInch)
					/ ((double)cxDIB * cxInch));
			rcDest.right = cxPage;
			*/
			//if printer page is too wide, expend to fill height, else to width.
			if (((float)cxPage/prefRect.Width()) > ((float)cyPage/prefRect.Height()))
			{
				pDoc->viewImageScale = pDoc->viewImageScale * cyPage/prefRect.Height();
			}
			else
			{
				pDoc->viewImageScale = pDoc->viewImageScale * cxPage/prefRect.Width();
			}
			pDoc->viewImageScale = 3;
		}
		else
			;//pDoc->viewImageScale = 1;

	}

	// paint background
	CBrush brush;
	if (!brush.CreateSolidBrush(RGB(255, 255, 255)))
		return;

	brush.UnrealizeObject();
	pDrawDC->FillRect(client, &brush);

	if (!pDC->IsPrinting() ||  !pDoc->m_fillWhenPrint)
	{
		CRect rc;
		GetClientRect(rc);
		pDoc->OnDraw(pDrawDC, rc);
		DrawCameraIcon(pDrawDC, rc);
		DrawCordinateBorder(pDrawDC, rc);
			

		/*
		sprintf(tmpBuf, "is not printing.\n");
		OutputDebugString(tmpBuf);
		sprintf(tmpBuf, "rc.Width(): %d.\n", rc.Width());
		OutputDebugString(tmpBuf);
		sprintf(tmpBuf, "rc.Height(): %d.\n", rc.Height());
		OutputDebugString(tmpBuf);
		*/
	}
	else
	{
		/*
		sprintf(tmpBuf, "is printing.\n");
		OutputDebugString(tmpBuf);
		sprintf(tmpBuf, "rect.Width(): %d.\n", rect.Width());
		OutputDebugString(tmpBuf);
		sprintf(tmpBuf, "rect.Height(): %d.\n", rect.Height());
		OutputDebugString(tmpBuf);
		*/

		::SetCursor(::LoadCursor(NULL, IDC_WAIT));


		pDoc->OnDraw(pDrawDC, rect);
		
		/*
		sprintf(tmpBuf, "after pDoc->OnDraw().\n");
		OutputDebugString(tmpBuf);
		*/
		
		DrawCameraIcon(pDrawDC, rect);
		
		/*
		sprintf(tmpBuf, "after DrawCameraIcon().\n");
		OutputDebugString(tmpBuf);
		*/
		
		DrawCordinateBorder(pDrawDC, rect);
		
		/*
		sprintf(tmpBuf, "is DrawCordinateBorder().\n");
		OutputDebugString(tmpBuf);
		*/

		::SetCursor(::LoadCursor(NULL, IDC_ARROW));
	}

	

	//reset value to original value.
	if (pDC->IsPrinting())
		pDoc->viewImageScale = oldViewImageScale;


	if (pDrawDC != pDC)
	{
		pDC->SetViewportOrg(0, 0);
		pDC->SetWindowOrg(0,0);
		pDC->SetMapMode(MM_TEXT);
		dc.SetViewportOrg(0, 0);
		dc.SetWindowOrg(0,0);
		dc.SetMapMode(MM_TEXT);
		pDC->BitBlt(rect.left, rect.top, rect.Width(), rect.Height(),
			&dc, 0, 0, SRCCOPY);
		dc.SelectObject(pOldBitmap);
	}
}


void CDibView::OnInitialUpdate()
{
    //CScrollView::OnInitialUpdate();
    //SetScrollSizes(MM_TEXT, sizeTotal, sizePage, sizeLine);
    CView::OnInitialUpdate();
}

/////////////////////////////////////////////////////////////////////////////
// CDibView printing

BOOL CDibView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CDibView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CDibView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CDibView diagnostics

#ifdef _DEBUG
void CDibView::AssertValid() const
{
	//CScrollView::AssertValid();
	CView::AssertValid();
}

void CDibView::Dump(CDumpContext& dc) const
{
	//CScrollView::Dump(dc);
	CView::Dump(dc);
}

CDibDoc* CDibView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDibDoc)));
	return (CDibDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDibView message handlers


void CDibView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	if (IsImageAdjustment())
	{
		CRect rc;
		GetClientRect(rc);
		int rc_center_x = rc.left + rc.Width()/2;
		int rc_center_y = rc.top + rc.Height()/2;

		CDibDoc* pDoc = GetDocument();
		int radius = (int) (ci_config_image->radius * pDoc->viewImageScale); //radius in pixel, default to 1/1 ratio

		// Get the range (height and width) of the image
		HGLOBAL original_hdib = pDoc->original_hdib;
		if(original_hdib!=NULL)
		{
			LPBITMAPINFOHEADER lpbi = (LPBITMAPINFOHEADER)GlobalLock(original_hdib);
			ImageHeight = lpbi->biHeight;
			ImageWidth  = lpbi->biWidth;
			GlobalUnlock(original_hdib);
		}
		else
		{
			ImageHeight = -1;
			ImageWidth  = -1;
		}

		CClientDC dc(this);
		OnPrepareDC(&dc);

		dc.DPtoLP(&point);
		int dx = point.x - rc_center_x;
		int dy = point.y - rc_center_y;

		LONG d = (LONG) ci_sqrt(dx*dx+dy*dy);
		if (abs(d - radius) <= 2 )
		{
			//if mouse is down on the crop circle, set it to resizing mode.
			SetCapture();
			m_bCaptured = TRUE;
			m_resizing = TRUE;
			m_pointMouse = point;
			// new mouse cursor is active while mouse is captured
			::SetCursor(::LoadCursor(NULL, IDC_CROSS));
		}
		else if (d < radius)
		{
			//if mouse is down within the crop circle, set it to moving mode.
			SetCapture();
			m_bCaptured = TRUE;
			m_resizing = FALSE;
			m_pointMouse = point;
			m_image_center.x = rc_center_x;
			m_image_center.y = rc_center_y;
			// new mouse cursor is active while mouse is captured
			::SetCursor(::LoadCursor(NULL, IDC_CROSS));
		}
	}
}

void CDibView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	if (IsImageAdjustment() && m_bCaptured) {
		::SetCursor(::LoadCursor(NULL, IDC_WAIT));
		ReleaseCapture();
		m_bCaptured = FALSE;
		m_resizing = FALSE;
		((CDibDoc*)GetDocument())->UpdateImages();
		//GetDocument()->UpdateAllViews(NULL);
		CRect rc;
		GetClientRect(rc);
		InvalidateRect(rc, FALSE);
		::SetCursor(::LoadCursor(NULL, IDC_ARROW));
	}
}

void CDibView::OnMouseMove(UINT nFlags, CPoint point) 
{
	CRect rc;
	GetClientRect(rc);
	int rc_center_x = rc.left + rc.Width()/2;
	int rc_center_y = rc.top + rc.Height()/2;
	int max_image_x = rc.Width() - 2 * VIEW_BORDER_X;
	int max_image_y = rc.Height() - 2 * VIEW_BORDER_Y;

	CDibDoc* pDoc = GetDocument();
	int radius = (int) (ci_config_image->radius * pDoc->viewImageScale); //radius in pixel, default to 1/1 ratio
	max_image_x = (int) (max_image_x / pDoc->viewImageScale);
	max_image_y = (int) (max_image_y / pDoc->viewImageScale);

	if (IsImageAdjustment())
	{
		CClientDC dc(this);
		OnPrepareDC(&dc);
		dc.DPtoLP(&point);
		if (m_bCaptured) {
			if (m_resizing)
			{
				//it is resizing the radius of the crop circle.
				CPoint offset(point);
				offset.x -= rc_center_x;
				offset.y -= rc_center_y;
				ci_config_image->radius = (LONG) ci_sqrt(offset.x*offset.x+offset.y*offset.y);
				radius = ci_config_image->radius;
				// Limits the adjusted size to the Window size
				if (ci_config_image->radius > max_image_x/2)
					ci_config_image->radius = max_image_x/2;
				if (ci_config_image->radius > max_image_y/2)
					ci_config_image->radius = max_image_y/2;
				ci_config_image->radius = (int) (ci_config_image->radius / pDoc->viewImageScale);
				// Limits to the image size
				if (ci_config_image->radius > ci_config_image->center_x)
					ci_config_image->radius = ci_config_image->center_x;
				if (ImageWidth != -1) {
					if (ci_config_image->radius + ci_config_image->center_x > ImageWidth)
						ci_config_image->radius = ImageWidth - ci_config_image->center_x;
				}
				if (ci_config_image->radius > ci_config_image->center_y)
					ci_config_image->radius = ci_config_image->center_y;
				if (ImageHeight != -1) {
					if (ci_config_image->radius + ci_config_image->center_y > ImageHeight)
						ci_config_image->radius = ImageHeight - ci_config_image->center_y;
				}

				CRect  rectNew(rc_center_x-radius-2, rc_center_y-radius-2,
								rc_center_x+radius+2, rc_center_y+radius+2); 
				dc.LPtoDP(rectNew);
			}
			else
			{
				//it is moving the center of the image.
				CPoint offset = point - m_pointMouse;
				m_pointMouse = point;
				int old_center_x = ci_config_image->center_x;
				int old_center_y = ci_config_image->center_y;

				ci_config_image->center_x -= (int) (offset.x / pDoc->viewImageScale);
				ci_config_image->center_y += (int) (offset.y / pDoc->viewImageScale);

				// Limits to the image size
				if (ci_config_image->center_x < ci_config_image->radius)
					ci_config_image->center_x = ci_config_image->radius;
				if (ImageWidth != -1) {
					if (ci_config_image->radius + ci_config_image->center_x > ImageWidth)
						ci_config_image->center_x = ImageWidth - ci_config_image->radius;
				}
				if (ci_config_image->center_y < ci_config_image->radius)
					 ci_config_image->center_y = ci_config_image->radius;
				if (ImageHeight != -1) {
					if (ci_config_image->radius + ci_config_image->center_y + offset.y > ImageHeight)
						ci_config_image->center_y = ImageHeight - ci_config_image->radius;
				}

				m_image_center.x += (long) ((old_center_x - ci_config_image->center_x) * pDoc->viewImageScale);
				m_image_center.y += (long) ((old_center_y - ci_config_image->center_y) * pDoc->viewImageScale);

				CRect  rectNew(m_image_center.x-ci_config_image->radius-2, m_image_center.y-ci_config_image->radius-2,
								m_image_center.x+ci_config_image->radius+2, m_image_center.y+ci_config_image->radius+2); 
				dc.LPtoDP(rectNew);
			}
			InvalidateRect(rc, FALSE);
			mainFrame->setConfigChanged(TRUE);
		    //*/
			//GetDocument()->UpdateAllViews(NULL);
		}
		else
		{
			//if not captured, show cursor as cross when it is on the
			//outer most ring.
			int dx = point.x - rc_center_x;
			int dy = point.y - rc_center_y;

			LONG d = (LONG) ci_sqrt(dx*dx+dy*dy);
			if (abs(d - radius) <= 2 )
				::SetCursor(::LoadCursor(NULL, IDC_SIZEALL));
		}
	}
}

void CDibView::DrawBlankoutRegion(int m_blankout_start, int m_blankout_end)
{
	CRect rc;
	GetClientRect(rc);
	InvalidateRect(rc, FALSE);
}

void CDibView::OnSize(UINT nType, int cx, int cy) 
{

	CView::OnSize(nType, cx, cy);
/*
	printf("cx: %d, cy: %d.\n", cx, cy);
	CDibDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	CRect rect;
	GetClientRect(rect);
	printf("rect.Width(): %d, rect.Height(): %d.\n", rect.Width(), rect.Height());
	CRect prefRect(0, 0, (int)(ci_config_image->max_msrbl_image_x * pDoc->viewImageScale) + 2 * VIEW_BORDER_X, (int)(ci_config_image->max_msrbl_image_y * pDoc->viewImageScale) + 2 * VIEW_BORDER_X);
	if (rect.Width() != prefRect.Width() || rect.Height() != prefRect.Height())
	{
		CRect frameRect;
		mainFrame->GetWindowRect(frameRect);
		mainFrame->SetWindowPos(NULL, 0, 0,
			frameRect.Width() + prefRect.Width() - rect.Width(),
			frameRect.Height() + prefRect.Height() - rect.Height(),
			SWP_NOZORDER|SWP_NOMOVE);
		InvalidateRect(rect, FALSE);
		return;
	}

	//CScrollView::OnSize(nType, cx, cy);
	
	sizePage.cx = rect.Width();
	sizePage.cy = rect.Height();
*/
	//SetScrollSizes(MM_TEXT, sizeTotal, sizePage, sizeLine);
	
}
