// IResultDialog.cpp : implementation file
//

#include "stdafx.h"
#include "dib.h"
#include "IResultDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CIResultDialog dialog


CIResultDialog::CIResultDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CIResultDialog::IDD, pParent), m_ResultText("")
{	
	//{{AFX_DATA_INIT(CIResultDialog)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

void CIResultDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CIResultDialog)
	DDX_Text(pDX, IDC_RESULT_EDIT, m_ResultText);
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CIResultDialog, CDialog)
	//{{AFX_MSG_MAP(CIResultDialog)
	ON_BN_CLICKED(ID_RESULT_OK, OnResultOk)
	ON_BN_DOUBLECLICKED(ID_RESULT_OK, OnDoubleclickedResultOk)
	ON_BN_CLICKED(ID_RESULT_SAVE, OnResultSave)
	ON_EN_UPDATE(IDC_RESULT_EDIT, OnUpdateResultEdit)
	ON_EN_CHANGE(IDC_RESULT_EDIT, OnChangeResultEdit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIResultDialog message handlers

void CIResultDialog::OnResultOk() 
{
	EndDialog(IDOK);
}

void CIResultDialog::OnDoubleclickedResultOk() 
{
	// TODO: Add your control notification handler code here
	
}

void CIResultDialog::OnResultSave() 
{

	char strbuffer[4][25],s[50];
	int n=-1,m=-1;

	CTime theTime = CTime::GetCurrentTime();
	strcpy(s,theTime.Format ( "%Y%m%d" ));
	strcat(s,"_*.rpt");
	CFileFind finder;
	BOOL bWorking = finder.FindFile(s);
	CString FN;
	if(bWorking)
	{
		while (bWorking)
		{
			bWorking = finder.FindNextFile();
			if(bWorking)
			{
				FN=finder.GetFileName();
				m=atoi(FN.Mid(9,4));
				if(m>n)n=m;
			}
		}
		FN=finder.GetFileName();
		m=atoi(FN.Mid(9,4));
		if(m>n)n=m;
	}
	strcpy(s,theTime.Format ( "%Y%m%d" ));
	if(n<0)
	{
		strcat(s,"_000.rpt");
	}
	else
	{
		sprintf(s,"%s_%03d.rpt",s,n+1);
	}


	strcpy (strbuffer[0],"CI-110 Report File (rpt)");
	strcpy (strbuffer[1],"*.rpt");
	strbuffer[2][0]='\0';
	strbuffer[2][1]='\0';
	strbuffer[3][0]='\0';
	strbuffer[4][1]='\0';

	//           default extension,filename,flags, file type
	CFileDialog dlg(FALSE, "rpt", s, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, "CI-110 Report File (rpt)");

	dlg.m_ofn.lpstrFilter=&strbuffer[0][0];
//	dlg.m_ofn.lpstrFile=s;

    if (dlg.DoModal() != IDOK)
	{
		return;	// TODO:  the open will fail if the user selects overwrite -- check the flag and allow
	}
//    CFile file;
//    file.Open(dlg.GetPathName(), CFile::modeWrite);
    FILE    *fp;

    if( ( fp = fopen(dlg.GetPathName(), "w" ) ) == NULL )
	{
		AfxMessageBox("File Open Error");
		return;
	}

	int length = m_ResultText.GetLength();
	LPTSTR src = m_ResultText.GetBuffer( length );
	fprintf(fp, src);
	fclose(fp);

	EndDialog(IDCANCEL);
}

void CIResultDialog::OnUpdateResultEdit() 
{
	// TODO: Add your control notification handler code here
	
}

void CIResultDialog::OnChangeResultEdit() 
{
	// TODO: Add your control notification handler code here
	
}


// IResultSFDialog.cpp : implementation file
//


