#ifndef _ASCII_H
#define _ASCII_H

/*
 * $Id: ascii.h 2.82 1997/01/14 19:01:33 Hong_Jiang Exp Hong_Jiang $
 */

/***********************************************************************
 *
 *      ASCII.H       C INCLUDE FILE (HJ)             ASCII.H
 *
 *      NAME
 *              ascii.h
 *
 *      SYNOPSIS
 *
 *      DESCRIPTION
 *
 *      FUNCTIONS:
 *
 *      RETURN VALUES
 *
 *      LINK
 *
 *      USAGE
 *
 *      FILES
 *
 *      SEE ALSO
 *
 *      COPYRIGHT
 *
 *      AUTHOR
 *              Hong Jiang
 *      DATE
 *
 *      BUGS
 *
 *      VERSION
 *
 * $Log: ascii.h $
 * Revision 2.82  1997/01/14  19:01:33  Hong_Jiang
 * TrueV2.22_DycamGator
 *
 * Revision 2.80  1997/01/12  22:41:05  Hong_Jiang
 * TrueV2.20_DycamGator
 *
 * Revision 2.75  1996/09/27  09:28:00  Hong_Jiang
 * TrueV2.15_DycamGator
 *
 * Revision 2.70  1996/07/16  10:46:20  Hong_Jiang
 * TrueV2.10_DycamGator
 *
 * Revision 2.63  1996/03/29  05:34:10  Hong_Jiang
 * TrueV2.04_DycamGator
 *
 * Revision 2.61  1996/03/27  07:52:56  Hong_Jiang
 * TrueV2.03_DycamGator
 *
 * Revision 2.60  1996/03/26  10:08:01  Hong_Jiang
 * TrueV2.02_DycamGator
 *
 * Revision 2.58  1996/03/26  09:45:00  Hong_Jiang
 * V2.02_DycamGator
 *
 * Revision 2.56  1996/03/19  18:02:13  Hong_Jiang
 * V2.01_DycamGator
 *
 * Revision 2.55  1996/03/19  16:42:52  Hong_Jiang
 * V2.01_DycamGator
 *
 * Revision 2.50  1995/12/23  03:35:04  Hong_Jiang
 * V2.00_DycamGator
 *
 * Revision 2.41  1995/12/23  03:29:58  Hong_Jiang
 * *** empty log message ***
 *
 * Revision 2.40  1995/10/20  07:40:14  Hong_Jiang
 * V1.60
 *
 * Revision 2.20  1995/07/22  03:31:22  Hong_Jiang
 * V151
 *
 * Revision 2.10  1995/05/09  03:31:48  Hong_Jiang
 * v1.50
 *
 * Revision 2.0  1995/03/21  06:47:22  Hong_Jiang
 * V1.50
 *
 * Revision 1.9  1995/03/19  09:40:08  Hong_Jiang
 * released 3-18-95
 *
 * Revision 1.2  1995/03/18  18:15:49  Hong_Jiang
 * uniform header for all files
 *
 *
 ************************************************************************/

#define CTRL_A          0x01
#define SOH             0x01
#define CTRL_B          0x02
#define STX             0x02
#define CTRL_C          0x03
#define ETX             0x03
#define CTRL_D          0x04
#define EOT             0x04
#define CTRL_E          0x05
#define ENQ             0x05
#define CTRL_F          0x06
#define ACK             0x06
#define CTRL_G          0x07
#define BEL             0x07
#define CTRL_H          0x08
#define BS              0x08
#define CTRL_I          0x09
#define TAB             0x09
#define HT              0x09
#define CTRL_J          0x0A
#define LF              0x0A
#define CTRL_K          0x0B
#define CTRL_L          0x0C
#define FF              0x0C
#define CTRL_M          0x0D
#define CR              0x0D
#define CTRL_N          0x0E
#define CTRL_O          0x0F
#define CTRL_P          0x10
#define CTRL_Q          0x11
#define DC1             0x11
#define CTRL_R          0x12
#define CTRL_S          0x13
#define DC3             0x13
#define CTRL_T          0x14
#define NAK             0x15
#define CTRL_U          0x15
#define CTRL_V          0x16
#define CTRL_W          0x17
#define CAN             0x18
#define CTRL_X          0x18
#define CTRL_Y          0x19
#define CTRL_Z          0x1A
#define CTRL_LBRAK      0x1B
#define ESC             0x1B
#define CTRL_BAKSL      0x1C
#define CTRL_RBRAK      0x1D
#define CTRL_CTRL       0x1E
#define CTRL__          0x1F
#define SP              0x20
#define DEL             0x7F

/* Constants of keys for function pause()                               */

#define KEY_UP          -72
#define KEY_DOWN        -80
#define KEY_LEFT        -75
#define KEY_RIGHT       -77
#define KEY_ENTER       13
#define KEY_PLUS        43
#define KEY_MINUS       45
#define KEY_ESCAPE      27
#define KEY_BACKSPACE   8

#endif