#if !defined(AFX_CIDPREMSRDIALOG_H__93E9E0A1_DD2D_11D1_9505_444553540000__INCLUDED_)
#define AFX_CIDPREMSRDIALOG_H__93E9E0A1_DD2D_11D1_9505_444553540000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// CIDPreMsrDialog.h : header file
//

#include "DibDoc.h"
#include "DibView.h"
#include "Mainfrm.h"

/////////////////////////////////////////////////////////////////////////////
// CCIDPreMsrDialog dialog

class CCIDPreMsrDialog : public CDialog
{
// Construction
public:
	CCIDPreMsrDialog(CDibDoc* pDoc, CWnd* pParent = NULL);   // standard constructor

	//A pointer to doc.
	CDibDoc* pDoc;
	
	//whether there is a blankout region or nor.
	BOOL	m_blankout_flag;
	//whether the blankout has been applied on image or not.
	BOOL	blankout_applied;

	void	UpdateState();

// Dialog Data
	//{{AFX_DATA(CCIDPreMsrDialog)
	enum { IDD = IDD_PRE_MSR_DIALOG };
	CButton	m_OKButton;
	CButton	m_CancelButton;
	CButton	m_ApplyButton;
	CEdit	m_BlankoutStartEditCtrl;
	CEdit	m_BlankoutEndEditCtrl;
	CSpinButtonCtrl	m_BlankoutEndCtrl;
	CSpinButtonCtrl	m_BlankoutStartCtrl;
	int		m_blankout_end;
	int		m_blankout_start;
	int		m_threshhold_level;
	double m_PARzerocal;
	double m_PARspancal;
	double m_Fleckszerocal;
	double m_Flecksspancal;
	double m_Latitude;
	int m_month1;
	int m_day1;
	int m_month2;
	int m_day2;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCIDPreMsrDialog)
	public:
	virtual BOOL DestroyWindow();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CCIDPreMsrDialog)
	afx_msg void OnChangePreMsrBlktEnd();
	afx_msg void OnChangePreMsrBlktStart();
	afx_msg void OnChangePreMsrThreshLevel();
	afx_msg void OnPreMsrButtonOk();
	afx_msg void OnPreMsrButtonCancel();
	afx_msg void OnPreMsrButtonApply();
	afx_msg void OnPreMsrRadioNo();
	afx_msg void OnPreMsrRadioYes();
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
	void DrawBlankoutRegion();
	void EnableControlsForBlankout(BOOL flag);
	BOOL m_Initialized;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CIDPREMSRDIALOG_H__93E9E0A1_DD2D_11D1_9505_444553540000__INCLUDED_)
